C  ---------------------------------------------------------------------
C
C             THIS PROGRAM WAS WRITTEN BY
C                        J.W. VISSER
C             OF THE TECHNISCH PHYSISCHE DIENST TNO-TH
C             P.O.BOX 155 DELFT NETHERLANDS.
C             IT CONTAINS MANY IDEAS AND SUGGESTIONS FROM
C                       PROF.DR. P.M. DE WOLFF
C             OF THE TECHNICAL UNIVERSITY (T.H) DELFT.
C
C
C             A DESCRIPTION OF THE PROGRAM WAS PUBLISHED IN
C             JOURNAL OF APPLIED CRYSTALLOGRAPHY.(1969) 2,89.
C
C
C             THIS WORK WAS LARGELY SPONSORED BY THE
C             JOINT COMMITTEE ON POWDER  DIFFRACTION STANDARDS
C             NOW AT  1601 PARK LANE, SWARTHMORE, PA. 19081
C             AND THE CENTRAL ORGANIZATION FOR  TNO, THE HAGUE,
C             NETHERLANDS.
C
C
C     THE PURPOSE OF THE PROGRAM IS TO FIND THE UNIT CELL FROM
C     THE POWDER PATTERN  OF COMPOUNDS OF LOW SYMMETRY.
C     ONE- AND TWO- PARAMETER PROBLEMS CAN BE SOLVED BY SIMPLER
C     METHODS.
C
C
C     THANKS ARE DUE TO   ROBIN SHIRLEY    OF THE UNIVERSITEY OF SURREY
C     WHO CONTRIBUTED MANY EXCELLENT IDEAS  AND ALSO MADE THE OUTPUT
C     MUCH BETTER UNDERSTANDABLE,
C                   AND
C     DR. GERALD G. JOHNSON JR. OF THE PENNSYLVANIA STATE UNIVERSITY
C     FOR MANY EXCELLENT IDEAS, SOME AS A RESULT FROM FEEDBACK BY USERS
C     IN THE U.S.A. TO WHOM HE DISTRIBUTED  THIS PROGRAM,   AND FOR
C     FORCING ME TO WRITE THIS PROGRAM IN A STANDARD (ANSI) LANGUAGE.
C
C
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C        THIS PROGRAM HAS PASSED THROUGH SEVERAL VERSIONS AND HAS
C     FOUND THE CORRECT UNIT CELL IN A LARGE NUMBER OF CASES. IT IS
C     POSSIBLE, HOWEVER, THAT UNDER SOME CIRCUMSTANCES, WITH A PARTICULA
C     SET OF DATA, OR WHEN USED WITH A PARTICULAR COMPUTER SYSTEM,
C     ERRONEOUS RESULTS WILL BE OBTAINED.
C     THE AUTHOR, THE  TECHNISCH PHYSISCHE DIENST TNO-TH, OR THE
C     JOINT COMMITTEE ON POWDER DIFFRACTION STANDARDS, THEREFORE, TAKE
C     NO RESPONSIBILITIES WHATSOEVER FOR  THE CORRECTNESS OF THE
C     PROGRAM OR THE RESULTS.
C        IT WOULD BE APPRECIATED IF ANY DISCREPANCIES IN THE PROGRAM
C     ARE BROUGHT TO THE ATTENTION OF THE AUTHOR, FOR IMPROVEMENTS IN
C     LATER VERSIONS.
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C                       VERSION  12        APRIL   1986
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C        VERSION 1
C             TRIALS TO MAKE THE  FORTRAN  PROGRAM EQUIVALENT TO
C             THE PL/I PROGRAM.
C        VERSION 2
C             PROVISIONS FOR MOLECULAR WEIGHT AND DENSITY.
C             PRINT-OUT OF INPUT CARDS.
C        VERSION 3
C             ADDITION OF THE PROCEDURE SYMTST (TESTING ON
C             HIGHER SYMMETRIES) AND LESSER IMPROVEMENTS.
C        VERSION 4.
C             ADAPTATIONS TO AVOID DIFFICULTIES ENCOUNTERED ON
C             OTHER MACHINES (INCLUDING OTHER IBM-MACHINES).
C             INTRODUCTION OF SUBROUTINE  ECHO IN CONNECTION
C             WITH BACKSPACE DIFFICULTIES.
C             MINOR CHANGES IN THE OUTPUT.
C             SUBROUTINES IN ALFABETICAL  ORDER.
C        VERSION 5
C             INSTRUCTION MANUAL
C             IMPROVED OUTPUT TEXT.
C             MORE TESTS ON INPUT.
C             TESTING ON HIGHER SYMMETRIES  IMPROVED.
C             AN EFFORT HAS BEEN MADE TO COMPLY WITH THE REQUIREMENTS
C             OF  *ANS* FORTRAN.  THIS WAS NOT EVERYWHERE POSSIBLE.
C        VERSION 6
C             MANY WISHES FROM USERS FULFILLED.
C             DISCLAIMERS, BOTH IN COMMENT ON MAIN AND IN OUTPUT.
C             MIXED-MODE ARITHMETIC REMOVED.
C             SUBROUTINE WRISP REWRITTEN FOR FASTER PRINTING.
C             POSSIBILITY TO PRINT AN INSTRUCTION MANUAL ON THE
C             SPECIAL FEATURES OF THE PROGRAM.
C             POSSIBILITY TO ENTER  INTENSITIES WITH THE LINES.
C             POSSIBILITY TO PRODUCE A LIST OF ALL CALCULATED AND
C             OBSERVED LINES.
C             POSSIBILITY TO ENHANCE CERTAIN CRYSTAL SYSTEMS. DUE TO
C             THE GENERAL CONSTRUCTION OF THE PROGRAM, THIS IS ONLY
C             POSSIBLE FOR ORTHORHOMBIC,MONOCLINIC OR TRICLINIC
C             LATTICES.
C             PROBABILITY TO  *HIT*  A LINE IS SUBDIVIDED OVER THE
C             Q RANGE.   CHANGES IN  CRITER.
C             ERROR LIMITS ON OBSERVED Q'S CALCULATED ONCE.  DISPLAYED
C             WHEN TEST=.TRUE.
C             OVERLAYS  TESTED.
C        VERSION 7
C             ALL  A-FORMATS REDUCED TO A1, EXCEPT THOSE THAT PRINT
C             INTENSITIES IN CHARACTER FORM (A3)-  THESE OCCUR  ONLY
C             IN *READER*, *LISTM* AND *REFINE* .
C             TRIES TO INDEX ALL LINES WITH THE UNIT CELL OF
C             THE BEST SOLUTION.
C             INSTRUCTIONS REWRITTEN, OTHER EXPLANATIONS EXTENDED.
C             THE USE OF ONE SET OF HKL'S TO EXPLAIN MORE THAN
C             ONE OBSERVED LINE  IS FLAGGED.
C             NUMBER OF SOLUTIONS THAT  ARE PRINTED OUT EXTENSIVELY
C             CAN BE CHANGED.
C        VERSION 8
C             INPUT FORMAT CHANGED-- ADDITIONAL PARAMETER CARD.
C             ZERO SHIFT (SPECIMEN DISPLACEMENT+TRANSPARENCY
C             CORRECTION ON DIFFRACTOMETER)--THE NEW PARAMETER CARD
C             STARTS WITH THE ZERO CORRECTION (ZERCOR), TO BE
C             APPLIED TO ALL ANGLES.
C             ZERCHK-- THE PROGRAM APPLIES 20 DIFFERENT ZERO SHIFTS
C             AND GIVES FOR EACH SHIFT THE NUMBER OF HIGHER ORDER
C             LINES THAT FIT--   IN THIS WAY IT SHOULD BE POSSIBLE
C             TO DECIDE WHETHER A ZERO SHIFT IS NECESSARY.
C             ONLY SOLUTIONS WITH A FIGURE OF MERIT THAT IS BETTER
C             THAN 4.0 ARE PRINTED--YOU MAY SET YOUR OWN MINIMUM
C             WITH PRNTMR.
C             WITH PRNTLN YOU CAN SET YOUR OWN MINIMUM OF INDEXED
C             LINES THAT IS NEEDED IN ORDER THAT THE LATTICE
C             WILL BE PRINTED.
C             FOR TRIAL, IT IS NOW POSSIBLE TO ENTER A DIRECT CELL.
C             COMBINATIONS OF ZONES WITH ITSELF NOW TRIES BOTH AXES
C             AS 'COMMON' AXES.
C             THE NUMBER OF CYCLES OF LATTICE REFINEMENT IS INCREASED.
C             *REFPAR* IS SPLIT INTO TWO SUBROUTINES,ONE OF WHICH
C             (REFPAR) SETS THE PARAMETERS FOR THE OTHER (REFINE)--
C             THE LATTER SUBROUTINE DOES THE ACTUAL CALCULATIONS.
C             TOLERANCES  ON FITTING LINES NOW EXPRESSED IN TWO THETA.
C             A(3) FORMATS CHANGED INTO A(2),1X.
C        VERSION 8.5
C                  THE MAIN PROGRAM IS NOW SPLIT INTO 3 PARTS,AABITO,
C             AAITO1 AND ANITO2--  THE NEW MAIN PROGRAM (AABITO)
C             COMMENTS, INITIALISES SOME VALUES AND CALLS READER, AAITO1
C             AND ANITO2.
C                  ZERCHK IS NOW OPTIONAL (COL. 33 IN PARAMETER CARD).
C                  THE SUBROUTINE *NTEST* LIMITS THE TEST OUTPUT TO
C             A SMALL PART OF THE PROGRAM, OR PRINTS ALL TEST OUTPUT
C             AFTER A CERTAIN POINT-- THE COMMENT IN THE SUBROUTINE
C             GUIDES YOU TO THE ACTUAL CALLS--  THE SUBROUTINE IS ONLY
C             USEFUL WHEN YOU ARE CHANGING PARTS OF THE PROGRAM.
C                  LATTICES THAT ARE DISCARDED IN *NORM3* ARE NOW
C             EXPLICITLY NAMED--  ALSO NAMED ARE THE LATTICES THAT ARE
C             DISCARDED BECAUSE THEY ARE  *EQUAL* TO OTHERS.
C        VERSION 9
C             SUBROUTINE READER WAS SPLIT IN TWO PARTS, READER  AND
C             REDLIN. THIS LAST SUBROUTINE READS THE INPUT LINES. IT
C             ALSO CALCULATES THE MAXIMUM ERROR (IN TWO THETA) THAT
C             YOUR INPUT DATA COULD HAVE IN ORDER TO BE ABLE TO PASS
C             THE TESTS (FIGURE OF MERIT .GT. 10)--
C             TWICE THIS MAXIMUM ERROR IS USED AS THE DEFAULT TOLG,
C             BUT ONLY IF TOLG REMAINS LESS THAN 0.060 DEGREES. --
C             ENTERING YOUR OWN TOLG OVERRIDES THE DEFAULTS.--
C             IN THE LIST OF ALL CALCULATED AND OBSERVED LINES,
C             THE UNINDEXED LINES ARE NOW MARKED CONSPICUOUSLY (IDEA
C             FROM CAM HUBBARD)--
C             THE FATE OF THE POSSIBLE LATTICES IS PRINTED IN FULL,
C             BUT ONLY IF YOU PRINT INTERMEDIATE RESULTS (ENL=TRUE)--
C             THE MINIMUM VALUES OF THE RECIPROCAL LATTICE CONSTANTS
C             NOW ALLOWS THE FIRST LINE TO BE A FOURTH ORDER. IN AN
C             EXPERIMENTAL PATTERN, WHICH WAS ORTHORHOMBIC  WITH
C             SPACEGROUP FDD2, THIS SITUATION ACTUALLY OCCURRED ---
C        VERSION 10  (A)
C                          FORTRAN 77
C             MODIFIED TO CONCUR WITH FULL FORTRAN 77.THIS ALLOWED A
C             SIMPLER VERSION OF SUBROUTINE ECHO.--
C             EXPLANATION OF THE VARIABLES IN COMMON BLOCKS IS
C             GIVEN IN THIS PROGRAM (BELOW). --
C             INDIVIDUAL PROBABILITIES FOR EACH LINE (FOR FINZON).--
C             CRITER CHANGED TO CONCUR WITH EARLIER IDEAS.--
C             SORTING OF ZONES IN THE NEW SUBROUTINE  *SRTZON* --
C               THE OUTPUT OF EVALUATE IS SORTED ON THE CRITERION
C             CRIT,  BUT IF NO CORRECT LATTICE IS OBTAINED, IT IS USED
C             AGAIN BUT SORTED ON THE NUMBER OF OBSERVED LINES (NO)
C             THAT MATCH THE ZONE. A SUBSORT IS MADE ON THE NUMBER OF
C             CALCULATED LINES (NC). THIS SOMETIMES LEADS TO SUCCES.--
C               THE PAPER BY MIGHELL AND STALICK IN 'ACCURACY IN POWDER
C             DIFFRACTION' HAS CONVINCED ME THAT IT IS NECESSARY TO
C             ENSURE THAT ALL AVAILABLE DATA (UP TO 40 LINES) IS
C             ENTERED INTO THE PROGRAM.
C             IF YOU NOW WANT TO ENTER LESS THAN 32 LINES, YOU GET A
C             WARNING AND YOU HAVE TO ENTER THE CORRECT NUMBER OF LINES
C             ON THE SECOND PARAMETER CARD.--
C                  A TRIAL WAS MADE IN REFINING THE ZONES ON THETA
C             INSTEAD OF Q. THIS DID NOT WORK AS WELL AS REFINING ON Q.
C             THEREFORE, ONLY THE BEST ZONES ARE (AT THE END OF THE
C             EVALUATION PROCESS) REFINED ON THETA IN ORDER TO
C             ESTABLISH  A ZERO-SHIFT FOR EACH ZONE.
C             SINCE I DO NOT KNOW YET HOW USEFUL THIS CAN BE, NOTHING
C             MUCH IS BEING DONE WITH IT.  IF YOU WANT TO, YOU CAN
C             USE THE INFORMATION BY ENTERING A CONVINCING
C             TWOTHETA-SHIFT INTO THE PROGRAM (REVERSE THE SIGN STATED
C             AND ENTER ON SECOND PARAMETER CARD IN COL 1-9). --
C                 LATTICES ARE ALSO REFINED ON TWOTHETA, TOGETHER
C             WITH A ZERO SHIFT. THE ZERO SHIFT IS STORED IN
C             ROSTER(I,11) AND PRINTED.
C
C        VERSION 11
C             ECHO CHANGED FOR THE USE OF *IOSTAT*. --
C             PRINTING OF Q-SCHEMES FOR THE LATTICES ONLY
C             WHEN TEST=TRUE. --
C             INSTRUCTIONS CLARIFIED. --
C             INPUT OF 32 LINES AND LESS WITHOUT DIFFICULTY AGAIN,
C             BUT WITH AMPLE WARNING. --
C             FINAL SORTING OF LATTICES ON: M20/(21-LINES INDEXED).--
C             A BIBLIOGRAPHY WAS ADDED IN THE TEXT OF THE NEW ROUTINE
C             BIBLIO. IT IS ANNOUNCED IN THE PROGRAM OUTPUT. --
C             THE NAME OF SUBROUTINE SRTRON WAS CHANGED INTO SRTLIN. --
C             CARDS (RECORDS) NO LONGER NUMBERED. --
C             FOR *EXPORT* PURPOSES THE PROGRAM PLUS SUBROUTINES WAS
C             DIVIDED INTO 6 FILES OF ABT. 820 RECORDS EACH. --
C
C      VERSION 12
C             OUTPUT OF A SUMMARY OF THE DATA OF THE BEST SOLUTION ON
C             UNIT NSUMM (66). THE LENGTH OF THE LINES IN THIS OUTPUT
C             IS RESTRICTED TO 70 CHARACTERS. --
C               SOMETIMES A MONOCLINIC LATTICE IS FOUND TO BE A
C             RHOMBOHEDRAL LATTICE IN DISGUISE. A REFINEMENT OF THE
C             HEXAGONAL LATTICE CONSTANTS IS NOW CARRIED OUT IN THE
C             NEW SUBROUTINE *REFSYM* , FOLLOWED BY A PRINT-OUT OF
C             THE PATTERN AS INDEXED ON HEXAGONAL AXIS. --
C                TETRAGONAL,HEXAGONAL AND CUBIC LATTICES ARE ALSO
C             RECOGNISED AND REFINED AS SUCH. THEY ARE PRINTED BY
C             THE NEW SUBROUTINE *SYMPRT*. --
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C           INPUT AND OUTPUT
C-----------------------------------------------------------------------
C  THE INPUT OF THE PROGRAM IS ON UNIT *INP*,
C  THE OUTPUT IS ON UNIT  *IOUT*.
C  THE SUBROUTINE  *ECHO* WRITES THE CARD IMAGES OF THE INPUT ON
C    AN EXTRA OUTPUT FILE, *IDOC*  (IDOC=14).
C  THIS EXTRA FILE IS ONLY USED IN *ECHO*
C  OUTPUT OF A SUMMARY ON UNIT  66.
C
C  IDOC, INP,IOUT AND NSUMM ARE SET TO RESP. 14,15,16,66 IN THIS MAIN
C  PROGRAM.
C  IF OTHER NUMBERS OF UNITS ARE WANTED, THESE CAN BE ENTERED THERE.
C
C
C     THE INPUT OF THIS PROGRAM SHOULD CONSIST OF:
C     1. A TITLE CARD,CONTAINING UP TO 80 CHARACTERS
C     2. TWO PARAMETER CARDS,THAT CAN BE COMPLETELY BLANK
C     3. A NUMBER OF LINES CARDS, CONTAINING THE POSITIONS OF THE LINES
C        THESE CAN BE ENTERED AS D-,Q- OR TWOTHETA VALUES. ( 8 F10.5 )
C        YOU MAY LEAVE ANY NUMBER OF POSITIONS PER CARD  BLANK.
C        THIS MEANS THAT YOU CAN ALSO ENTER ONLY ONE LINE PER CARD,
C        IN ANY ONE OF THE POSITIONS OF 8F10.5
C     4. A BLANK CARD, TO FINISH THE INPUT OF ONE PROBLEM.
C
C        REPEAT THE ABOVE  AS MANY TIMES AS PROBLEMS,   -- THEN --
C     5. A CARD CONTAINING THE WORD  --  END  -- IN THE THREE FIRST
C        COLUMNS,  TO FINISH THE INPUT.
C
C  THE PROGRAM WILL TAKE ITS OWN (DEFAULT) PARAMETERS.
C  FOR THE INITIATED THE SUBROUTINE READER GIVES FULL DETAILS ABOUT
C  ALL THE  POSIBILITIES OF THE PROGRAM.
C
C
C-----------------------------------------------------------------------
C              THE SUBROUTINES  ARE  LISTED  IN  ALFABETICAL  ORDER.
C-----------------------------------------------------------------------
C
C                         GENERAL FLOW OF SUBROUTINES
C        (THE ACTUAL FLOW OF SUBROUTINES IS SLIGHTLY MORE COMPLICATED)
C-----------------------------------------------------------------------
C      SUBROUTINES TIMER AND NTEST ARE FREQUENTLY CALLED BY THE
C      MAIN PROGRAM. NTEST CALLS ARE MARKED BY 1+ , 2+ , ETC.
C.......................................................................
C
C
C        *******            *******           **********
C        *     *            *     * <-------> *  ECHO  *        ********
C        *  M  *            *  R  *           **********   |--> *SRTLIN*
C        *     *            *     * <-------> * REDLIN * <-|    ********
C      1+*  A  * <--------> *  E  *           **********   |--> *TETCAL*
C        *     *            *     * <-------> * RECCEL *        ********
C        *  I  *            *  A  *           **********
C        *     *            *     * <-------> * MANUAL *
C        *  N  *            *  D  *           **********
C   |--->*     *            *     * <-------> * INSTRS *
C   |    *******            *  E  *           **********
C   |       |               *     * <-------> * ZERCHK *
C   |       |               *  R  *           **********
C   |       |               *     * <-------> * BIBLIO *
C   |       |               *******           **********
C   |       |
C   |  2+*******            **********
C   |    *     *  <-------> * FINZON *
C   |    *     *            **********
C   |    *  A  *
C   |    *     *            *******           ******         *********
C   |    *     *            *     *  <------> * LS *  <----> * WRISP *
C   |    *     *            *  E  *           ******         *********
C   |    *  A  *            *  V  *           ********
C   |    *     *            *  A  *  <------> * NORM *
C   |    *     *  <-------> *  L  *           ********
C   |    *     *            *  U  *           **********
C   |  3+*  I  *            *  8  *  <------> * CRITER *
C   |    *     *            *     *           **********
C   |    *     *            *     *           *********
C   |    *     *            *******  <------> * TEXT1 *
C   |    *     *                              *********
C   |    *  T  *            **********
C   |    *     *  <-------> * SRTZON *
C   |    *     *            **********
C   |  4+*     *
C   |    *  O  *            **********
C   |    *     *  <-------> * ONEZON *
C   |    *     *            **********
C   |    *     *
C   |    *  1  *
C   |    *     *            ********
C   |  5+*     *  <-------> * REAR *
C   |    *******            ********
C   |
C   |
C   |
C   |    *******            **********
C   |--->*     *  <-------> * THREED *
C        *     *            **********
C      6+*     *
C        *     *            *********          **********
C        *     *  <-------> * NORM3 * <------> * WISSEL *
C        *  A  *            *********          **********
C        *     *
C      7+*     *
C        *     *
C      8+*     *        *******        *******           **********
C        *  N  *        *     *        *     *  <------> *        *
C        *     *        *  R  *        *  R  *           **********
C        *     *        *     *        *     *           *********
C        *     *        *  E  *        *  E  *  <------> * WRISP *
C        *     *        *     *        *     *           *********
C        *  I  * <----> *  F  * <----> *  F  *           *********
C        *     *        *     *        *     *  <------> * ARRAY *
C        *     *        *  P  *        *  I  *           *********
C        *     *        *     *        *     *           ********
C        *     *        *  A  *        *  N  *  <------> * MINV *
C        *  T  *        *     *        *     *           ********
C        *     *        *  R  *        *  E  *           *********
C        *     *        *     *        *     *  <------> * LISTM *
C        *     *        *******        *******           *********
C      9+*     *
C        *  O  *            **********
C        *     *  <-------> * UNTCEL *
C        *     *            **********
C        *     *
C        *  2  *            **********         **********
C        *     *  <-------> * SYMTST * <-----> * REFSYM *
C        *     *            **********         **********
C        *     *
C        *     *            **********
C        *     *  <-------> * SRTSYM *
C        *     *            **********
C        *     *                               **********
C        *     *            ********** <-----> *  LISTM *
C        *     *  <-------> * SYMPRT *         **********
C        *     *            ********** <-----> * REFSYM *
C        *     *                               **********
C        *******
C
C-----------------------------------------------------------------------
C                       MINIMISING STORAGE REQUIREMENTS.
C-----------------------------------------------------------------------
C                       ONLY VALID FOR VERSION 6.
C                FOR NEWER VERSIONS IT CAN SERVE AS A GUIDE.
C.......................................................................
C
C     1. OVERLAY.
C
C             THE SUGGESTED OVERLAY STRUCTURE NEEDS ONLY ABOUT 60%
C             OF THE STORAGE NEEDED FOR THE FULL PROGRAM,
C             WITHOUT IMPAIRING ITS EFFICIENCY.
C             THE SUBROUTINES  *FINZON*  AND *THREED*  HAVE THE
C             LARGEST REQUIREMENTS FOR MAIN STORAGE.    THEREFORE, IT IS
C             NOT NECESSARY TO GO BEYOND ONE LEVEL OF OVERLAY.
C             I SUGGEST THE FOLLOWING SCHEME
C
C             ENTRY  MAIN      COMMENT* ROOT SEGMENT, SEGMENT 1
C             OVERLAY ONE
C             INCLUDE SUB(READEM)     COMMENT*  SEGMENT 2
C             OVERLAY ONE
C             INCLUDE SUB(FINZON)     COMMENT* SEGMENT 3
C             OVERLAY ONE
C             ETC.  ETC.  ETC.
C
C             SEGMENT     CONTENTS
C                1        MAIN + COMMONS, EXCEPT *COUNTM*
C                2        READER+ECHO+MANUAL+INSTRS+SRTLIN
C                3        FINZON
C                4        EVALU8+LS+WRISP+NORM+CRITER+TEXT1
C                5        ONEZON+REAR
C                6        THREED
C                7        NORM3
C                8        REFPAR+WISSEL+ARRAY+MINV+LISTM+ *PRINS*
C                9        UNTCEL+SYMTST
C
C             THE FOLLOWING CHANGES ARE NECESSARY
C             A.DELETE THE COMMON *COUNTM* THROUGHOUT THE PROGRAM,
C               USE AN ARRAY  *ITL(5000)* INSTEAD OF THIS COMMON
C               IN THE SUBROUTINES *FINZON* AND *THREED*
C             B.DELETE THE SUBROUTINE CALL FOR *NORM3* FROM *REFPAR*
C               INSERT A CARD      95 CONTINUE
C             C.CHANGE THE NAME OF THE SUBROUTINE *WRISP* IN *REFPAR*
C               INTO SOMETHING DIFFERENT, LIKE *PRINS*  AND CHANGE THE
C               FOUR SUBROUTINE CALLS FOR *WRISP* IN *REFPAR*
C               ACCORDINGLY
C             THE CALL FOR *NORM3* IN *REFPAR* IS ONLY SELDOM
C             REALLY NECESSARY,  HOWEVER,
C             IF THE RESULTS OF A PARTICULAR POWDER PATTERN SEEM STRANGE
C             TO YOU, YOU CAN ALWAYS FORCE ANOTHER APPLICATION OF *NORM3
C             BY RE-ENTERING YOUR DATA AND THE STRANGE LATTICES,
C             SEE  MANUAL AND INSTRUCTIONS, USE COL 44 OF PARAMETER CARD
C
C
C     1B OVERLAY 2.
C
C             ON AN IBM 370/158 THE PROGRAM RAN IN  84K INSTEAD OF 140
C             AND WITHOUT MEASURABLE LOSS OF SPEED WITH THE FOLLOWING
C             SCHEME
C             A. COMPILE THE PROGRAM AS GIVEN WITH  PARM.LKED=OVLY
C             B.GIVE  LKED.SYSIN  DD  *
C                ENTRY MAIN
C                INSERT MAIN
C                OVERLAY  ALPHA
C                  INSERT READER,MANUAL,ECHO,INSTRS,SRTLIN,IHCSSCN
C                OVERLAY  ALPHA
C                  INSERT FINZON,THREED,COUNTM
C                OVERLAY  ALPHA
C                  INSERT EVALU8,LS,NORM,CRITER,TEXT1,EVALN,LINSTR,IHCSE
C                  INSERT REFPAR,WISSEL,WRISP,ARRAY,MINV,NORM3,LISTM
C                OVERLAY  ALPHA
C                  INSERT ONEZON,REAR,UNTCEL,SYMTST
C             /*
C
C
C     2. CHOPPING UP THE PROGRAM.
C
C             IF YOU HAVE A REALLY SMALL COMPUTER, IT IS STILL
C             POSSIBLE TO RUN THIS PROGRAM.
C             AS THE PROGRAM USES ITS MAIN SUBROUTINES SEQUENTIALLY,
C             IT IS POSSIBLE TO IMITATE AN OVERLAY AND DIVIDE THE MAIN
C             PROGRAM IN A NUMBER OF PIECES THAT WILL WORK AS
C             SEPARATE UNITS.  AFTER EVERY PART IT WILL BE NECESSARY
C             TO SAVE THE VALUES OF MOST COMMON AREAS AND OF THE
C             ARRAY  *STORE*.    THE DIVISION OF THE PROGRAM SHOULD
C             FOLLOW THE SAME MAIN LINE  AS THE  OVERLAY STRUCTURE.
C             I HAVE NOT TRIED THIS MYSELF, AS I HAVE A VERY LARGE
C             COMPUTER AVAILABLE.  I AM QUITE WILLING TO HELP ANYBODY
C             WHO TRIES THE ABOVE IDEA.   PLEASE CONTACT ME .
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C                EXPLANATION OF VARIABLES IN  COMMON.
C
C     1.LINES
C       IDOC     OUTPUT FILE FOR DOCUMENTATION PURPOSES. LISTS INPUT
C                AS GIVEN
C       INP      INPUT UNIT,FROM WHICH ALL INPUT IS READ.
C       IOUT     STANDARD OUTPUT UNIT (LINE PRINTER)
C      (NSUMM    OUTPUT UNIT FOR CRT-TERMINAL IS IN COMMON CONSTS)
C       MAX      THE NUMBER OF OBSERVED LINES THAT ARE USED (.LE. 40)
C       OBS(40)  CONTAINS THE Q-VALUES OF THE OBSERVED LINES.
C       CEL(10)  USED FOR SEVERAL PURPOSES, CAN CONTAIN UNIT CELLS
C                OR LINE COMBINATIONS OR ZONES.
C    2. CHARCM
C       NAME     NAME OF PROBLEM.
C       CARD     CONTAINS THE IMAGE OF THE 'CARD' THAT WAS LAST READ.
C       INTSY(50) CONTAINS THE INTENSITIES (GIVEN AS  VS , S , ETC.)
C                OF THE OBSERVED LINES.
C    3. PARMS
C       TOL2     TOLERANCE ON 2-DIMENSIONAL SEARCH FOR THE ANGLE BETWEEN
C                THE DIRECTIONS OF THE POINTS REPRESENTED BY Q-VALUES.
C       TOL3     SAME FOR THREE-DIMENSIONAL SEARCH (FOR D)
C       WAVEL    WAVELENGTH  (1.5406 BY DEFAULT)(1.5405891)
C       FMINEQ   MAXIMUM VALUE FOR THE DIFFERENCE BETWEEN 'EQUAL' VALUES
C       FMINIM   MINIMUM VALUE FOR THE FIRST THREE LATTICE CONSTANTS.
C       SELF     LOGICAL
C       ENL      LOGICAL FOR PRINTING INTERMEDIATE RESULTS.
C       TEST     LOGICAL FOR PRINTING ALL TEST RESULTS.
C       LIST     THE NUMBER OF LATTICES THAT ARE TO BE PRINTED OUT
C       NSYST(3) SEE INSTRUCTIONS. POSSIBILITY TO ENHANCE SOME CRYSTAL
C                SYSTEMS
C       OBSMT(40) Q-VALUES OF THE OBSERVED LINES MINUS TOLERANCE.
C       OBSPT(40) Q-VALUES OF THE OBSERVED LINES PLUS THE  TOLERANCE.
C       TWTHET(40) TWO-THETA'S OF THE OBSERVED LINES.
C       TOLG     TOLERANCE (IN HUNDREDTH OF A DEGREE  TWO THETA)
C
C    4. EVALN
C       NORDER   NUMBER OF ORDERS OF AXES' Q-VALUES, USUALLY 4.
C                NORDER DETERMINES THE INDEX-FIELD OF THE ZONES AT
C                EVALUATION.
C       RECTAN   LOGICAL THAT IS .TRUE. WHEN THE ZONE IS RECTANGULAR.
C       PROB(40) PROBABILITY TO 'HIT' AN OBSERVED LINE BY CHANCE.
C       EVAL(-8:8,0:8) ARRAY CONTAINING THE PROBABILITIES OF THE
C                CALCULATED LINES THAT ARE ALSO OBSERVED.
C       UPBNDR(40) UPPER BOUNDARY OF THE PROBABILITY FIELD OF EACH LINE.
C
C    5. TEMRES
C       LINCO    THE NUMBER OF LINE COMBINATIONS
C       NQ2      THE NUMBER OF THE LAST LINE TO BE COMBINED WITH OTHERS.
C       NINDEX   THE NUMBER OF LINES INDEXED AMONG THE FIRST NQ2 LINES
C       INDEX(40) ARRAY TO COUNT WHETHER A LINE WAS INDEXED BY A
C                PARTICULAR ZONE.
C       ROSTER(150,12) ARRAY IN WHICH THE USEFUL LATTICES ARE STORED.
C
C    6. CONSTS
C       NSUMM    NUMBER OF UNIT ONTO WHICH A SUMMARY IS WRITTEN.
C                THE LENGTH OF THE LINES IS LESS THAN 71 CHARACTERS.
C       RAD,TWORAD FACTORS FOR CALCULATING DEGREES FROM RADIANS.
C       RRAD     FACTOR TO CALCULATE RADIANS FROM DEGREES (RECIPROCAL)
C       HLFLAM   WAVELENGTH/(2*100). FACTOR 100 STEMS FROM THE FACT
C                THAT Q HAS BEEN MULTIPLIED BY 100**2
C       WAVSQR   CONSTANT NEEDED FOR CALCULATING DERIVATIVES.
C       STORE(200,9) ARRAY TO STORE THE ZONES.
C
C    7. THETAS   --- ALL IN RADIANS ---
C       ZERTOT   TOTAL ZERO SHIFT OF THE DATA (RADIANS).
C       OBSTET   OBSERVED THETA.
C       SHFTET   OBSERVED THETAS, SHIFTED BY THE CALCULATED ZEROSHIFT.
C       TETPT    OBSERVED THETA PLUS TOLERANCE
C       TETMT    OBSERVED THETA MINUS TOLERANCE.
C
C    8. HISYM    DATA FOR HIGH-SYMMETRY LATTICES
C       ISOL     THE NUMBER OF THE SOLUTION
C       SYMCON(12,6) ARRAY TO STORE THE CELCONSTANTS OF THE HIGHLY
C                SYMMETRIC LATTICES. 1,2 CELCONSTANTS,3=CRYSTAL SYSTEM,
C                4=NUMBER OF LINES INDEXED,5=ZEROSHIFT, 6=VOLUME.
C       NMATCH(45) ARRAY TO STORE THE NUMBER OF CALCULATED LINES THAT
C                MATCH EACH OBSERVED LINE.
C
C    9. COUNTM
C       ITL(0:5000) ARRAY TO FIND THE VALUES OF  *F*  AND  *D* .
C                IT IS NOT NECESSARY TO PUT THE ARRAY(S) IN A COMMON,
C                BUT IT SAVES SPACE.
C
C
C
C-----------------------------------------------------------------------
      LOGICAL SELF,ENL,TEST,SOL,RECTAN
      CHARACTER NAME*80,CARD*80,INTSY*2
      COMMON /LINES / IDOC,INP,IOUT,MAX,OBS(40),CEL(10)
      COMMON /CHARCM/ NAME,CARD,INTSY(50)
      COMMON /PARMS / TOL2,TOL3,WAVEL,FMINEQ,FMINIM,SELF,ENL,TEST,LIST,
     *                NSYST(3),OBSMT(40),OBSPT(40),TWTHET(40),TOLG
      COMMON /EVALN / NORDER,RECTAN,PROB(40),EVAL(-8:8,0:8),
     *                UPBNDR(40)
      COMMON /TEMRES/ LINCO,NQ2,NINDEX,INDEX(40),ROSTER(150,12)
      COMMON /CONSTS/ NSUMM,RAD,TWORAD,RRAD,HLFLAM,WAVSQR,STORE(200,9)
      COMMON /COUNTM/ ITL(0:5000)
      IDOC=14
      INP=15
      IOUT=16
      NSUMM=6
      OPEN(UNIT=IDOC  ,FILE='ITODOC.LST')
      OPEN(UNIT=INP   ,FILE='ITOINP.DAT')
      OPEN(UNIT=IOUT  ,FILE='ITOUT.LST' )
C     OPEN(UNIT=NSUMM ,FILE='ITOSUM.LST')
      WRITE(NSUMM, 99)
   99 FORMAT(' THE ITO-PROGRAM STARTS NOW.'  //
     2 ' THE PROGRAM WRITES THE SUMMARY OF THE OUTPUT ONTO'/
     3 ' YOUR SCREEN WHILE IT IS WORKING.' /
     4 ' IF YOU PUT ON  CTRL+PRTSCRN  YOU WILL GET THE SUMMARY' /
     5 ' OF THE OUTPUT PRINTED OUT DURING THE CALCULATING PROCESS.'/
     6 ' THERE IS NO OTHER WAY OF OBTAINING THIS SUMMARY.'///
     7 ' You have to give  ENTER  at least once to resume'/
     8 ' the calculations.' )
      PAUSE
      NORDER=4
      NRMAX=200
   1  CONTINUE
      CALL TIMER(0)
      NRRUN=0
      DO 10 I=1,150
         DO 5 J=1,12
   5     ROSTER(I,J)=0.0
  10  CONTINUE
C
      CALL READER(NZ1,NZ2,NR,NSOLMX,WMOL,DOBS,PRNTMR,PRNTLN,NTST)
C
      IF (MAX .LT. 11) GO TO 1
      IF (INP .EQ. 12345)  GO TO 9000
      CALL TIMER(1)
  100 SOL=.TRUE.
      IF (NR .EQ. 0) THEN
         NRRUN=NRRUN+1
         SOL=.FALSE.
         CALL AAITO1(NZ1,NZ2,NR,NRMAX,NTST,NRRUN)
      END IF
      CALL ANITO2(SOL,NR,NSOLMX,WMOL,DOBS,PRNTMR,PRNTLN,NTST,NRRUN)
C  NRRUN=1 SIGNALS THAT NO REALLY SATISFACTORY SOLUTION HAS BEEN FOUND
C  IN THE FIRST TRIAL. WE NOW TRY AGAIN, USING THE SAME ZONES BUT
C  SORTING THEM DIFFERENTLY.
      IF (NRRUN .EQ. 1) THEN
         NR=0
         GO TO 100
      ELSE
         GO TO 1
      END IF
 9000 STOP
      END
      SUBROUTINE AAITO1(NZ1,NZ2,NR,NRMAX,NTST,NRRUN)
C  THIS IS THE FIRST PART OF THE --ITO-- PROGRAM
C  LAST CHANGED: 080585,14.00H ,  ADDED SUMMARY OUTPUT.
      DIMENSION TEMP(0:41)
      LOGICAL SELF,ENL,TEST,RECTAN
      CHARACTER NAME*80,CARD*80,SNAME*70,INTSY*2
      COMMON /LINES / IDOC,INP,IOUT,MAX,OBS(40),CEL(10)
      COMMON /CHARCM/ NAME,CARD,INTSY(50)
      COMMON /PARMS / TOL2,TOL3,WAVEL,FMINEQ,FMINIM,SELF,ENL,TEST,LIST,
     *                NSYST(3),OBSMT(40),OBSPT(40),TWTHET(40),TOLG
      COMMON /EVALN / NORDER,RECTAN,PROB(40),EVAL(-8:8,0:8),
     *                UPBNDR(40)
      COMMON /TEMRES/ LINCO,NQ2,NINDEX,INDEX(40),ROSTER(150,12)
      COMMON /CONSTS/ NSUMM,RAD,TWORAD,RRAD,HLFLAM,WAVSQR,STORE(200,9)
      IF (NRRUN .EQ. 2) THEN
         DO 9 J=1,12
             DO 8 I=1,150
    8        ROSTER(I,J)=.0
    9    CONTINUE
         DO 10 I=1,200
         IF (STORE(I,1) .LT. 0.1) GO TO 15
   10    CONTINUE
   15    NR=I-1
         NSRT=7
         NZ1=NZ1+2
         NZ2=NZ2+2
         WRITE(IOUT ,9922)
         WRITE(NSUMM,9922)
         GO TO 500
      END IF
      DO 30 I=1,200
      DO 20 J=1,9
   20 STORE(I,J)=0.0
   30 CONTINUE
      DO 40 I=1,MAX
   40 TEMP(I)=OBS(I)
      TEMP(0)=0.5*OBS(1)
      TEMP(MAX+1)=2.0*OBS(MAX)-OBS(MAX-1)
      DO 50 I=1,MAX
      UPBNDR(I)=0.5*( TEMP(I)+TEMP(I+1) )
      PROB(I)=2.0*(OBSPT(I)-OBSMT(I))/(TEMP(I+1)-TEMP(I-1))
      IF (PROB(I) .GT. 0.5) PROB(I)=0.5
   50 CONTINUE
      IF (TEST) WRITE(IOUT,9915) UPBNDR
      IF (TEST) WRITE(IOUT,9916) PROB
      CALL NTEST(NTST,2)
      NN=0
C-----------------------------------------------------------------------
C--FINDING ZONES STARTS HERE.
C-----------------------------------------------------------------------
    2 IF (ENL)  THEN
         WRITE(IOUT,9909)NAME
         IF (NN .EQ. 0) WRITE(IOUT,9901)
         WRITE(IOUT,9905)
      END IF
      NN=NN+1
      NR=0
      DO 350 J=1,LINCO
      IF (ROSTER(J,3) .LT. 0.05  .AND.  ROSTER(J,4) .LT. 0.05)GO TO 320
      NR=NR+1
      DO 310 I=1,4
  310 STORE(  NR,I)=ROSTER(J,I)
      STORE(NR,5)=NR
      IF (ENL) WRITE(IOUT,9903) NR  , (STORE(NR  ,K),K=1,4)
      GO TO 350
  320 CALL FINZON(ROSTER(J,1),ROSTER(J,2) )
      DO 330 I=1,5
      N=CEL(I+5)+0.5
      IF (N .EQ. 0) GO TO 350
      IF (NR.GE.NRMAX) THEN
         WRITE(IOUT,9920) NRMAX
         GOTO 360
      END IF
      NR=NR+1
      STORE( NR ,1)=ROSTER(J,1)
      STORE( NR ,2)=ROSTER(J,2)
      STORE( NR ,3)=CEL(I)
      STORE(NR,4)=.0
      STORE(NR,5)=NR
      IF (ENL) WRITE(IOUT,9904)   NR ,(STORE(  NR ,K),K=1,3),N
  330 CONTINUE
  350 CONTINUE
C  ---------------------------------------------------------------------
C-- END OF FINDING ZONES.
C--THE EVALUATION OF THE ZONES FOUND STARTS HERE
C  ---------------------------------------------------------------------
  360 CONTINUE
      CALL TIMER(2)
      MILNR=NR
      IF (TEST) WRITE(IOUT,9917)
      DO 450 I=1,NR
      IF (I .EQ. 6) TEST=.FALSE.
C--THIS GIVES 5 ZONES (10 PAGES) WITH TEST OUTPUT.
C--IF YOU WANT MORE WASTEPAPER, CHANGE  6  INTO  NR.
C  IF YOU WANT TO SEE THE TEST OUTPUT OF A PARTICULAR ZONE,
C  YOU CAN ENTER THIS ZONE (AND MAYBE SOME OTHERS) WITH LINCO
C  (SEE MANUAL AND INSTRUCTIONS).
      IF (STORE(I,4) .GT. 1.0) GO TO 450
      CALL EVALU8(I,1)
      IF (STORE(I,1) .LT. FMINIM) STORE(I,4)=-10.
      IF (TEST)WRITE(IOUT,9930) I,(STORE(I,K),K=1,8),STORE(I,9)*TWORAD
C  ---------------------------------------------------------------------
C  THE FOLLOWING 7 PROGRAM CARDS CAN BE USED TO STORE THE ORIGINAL ZONE
C  TOO, WHEN ONE OF ITS AXES OR BOTH HAVE BEEN HALVED IN THE EVALUATION
C  PROCESS.   .
C  THE FEATURE IS ONLY SELDOM USEFUL AND ADDS ABOUT 10-20% COMPUTING TIM
C  OF THE PROBLEM. I DO NOT RECOMMEND IT.
C     U=0.0
C     DO  410 J=1,3
C 410 U=U+ABS(STORE(I,J)-CEL(J))
C     IF ( U .LT. 2.0*FMINEQ) GO TO 450
C     MILNR=MILNR+1
C     DO 420 J=1,6
C 420 STORE(MILNR,J)=CEL(J)
C  ---------------------------------------------------------------------
C  ---------------------------------------------------------------------
  450 CONTINUE
      NR=MILNR
      CALL NTEST(NTST,2)
C--RESTORES TEST FOR OTHER TEST OUTPUT.
C  ---------------------------------------------------------------------
C--ZONES HAVE BEEN  EVALUATED AND WILL NOW BE SORTED ON QUALITY.
C-----------------------------------------------------------------------
      NSRT=4
  500 CALL SRTZON(NSRT,NR,NZ2)
      IF (NR .GT. NZ2+2) NR=NZ2+2
C-----------------------------------------------------------------------
C  EVALU8 GIVES A FINAL ROUND OF LS AND PRINTS THE LATTICE WHEN ENL=.TRU
C  AT THE SAME TIME A CHECK IS MADE TO SEE WHETHER ALL OR NEARLY ALL
C  LINES USED FOR ZONE-FINDING BELONG TO ONE ZONE
C  ATTENTION:  THIS LAST CHECK IS NOT (REPEAT   NOT)  MADE WHEN YOU
C  HAVE ENTERED YOUR OWN LINE COMBINATIONS.
C-----------------------------------------------------------------------
      CALL NTEST(NTST,3)
      N=0
      DO 700 I=1,NR
      CALL EVALU8(I,2)
      IF (STORE(I,1) .LT. FMINIM) GO TO 700
      N=N+1
      DO 640 J=1,9
  640 STORE(N,J)=STORE(I,J)
C--CHECK WHETHER THE ZONE INDEXES ALL BUT ONE OF THE FIRST NQ2
C--LINES USED FOR ZONEFINDING.
      IF (NINDEX .LT. NQ2-1) GO TO 700
      IF (NN .GE. 2) GO TO 700
C--FIRST TIME THROUGH (NN). MAKE NEW LINE COMBINATIONS.
      IF (ENL) WRITE(IOUT,9908)  NINDEX,NQ2
      DO 680 J=1,N
      DO 660 K=1,4
  660 ROSTER(J,K)=STORE(J,K)
  680 CONTINUE
      LINCO=N
      CALL ONEZON(STORE(I,1),STORE(I,2),STORE(I,3))
      WRITE(IOUT,9902)  I,NINDEX,NQ2
      GO TO 2
  700 CONTINUE
      NR=N
C---------------------------------------------------------------------
C  REFINE ON TWOTHETA IN ORDER TO FIND A  ZERO SHIFT.
C---------------------------------------------------------------------
      DO 750 I=1,NR
         IF (STORE(I,7) .GT. 3. ) CALL EVALU8(I,3)
  750 CONTINUE
      SNAME=NAME
      WRITE(IOUT,9909) NAME
      WRITE(IOUT,9910)
      WRITE(IOUT,9911) (I,(STORE(I,J),J=1,8),TWORAD*STORE(I,9),I=1,NR)
      WRITE(IOUT,9912)
      WRITE(NSUMM,9989) SNAME
      WRITE(NSUMM,9981) (I,(STORE(I,J),J=1,8),TWORAD*STORE(I,9),I=1,NR)
      CALL TIMER(3)
C  ---------------------------------------------------------------------
C  THE SUBROUTINE  REAR  REARRANGES ZONES AND TRIES TO FIND A COMMON
C  LINE IN THE RECIPROCAL LATTICE.
C  A COMMON Q-VALUE CLOSE TO THE ORIGIN IS ALL THAT IS NEEDED.
C  ---------------------------------------------------------------------
  800 IF (NZ1 .GT. NR) NZ1=NR
      CALL NTEST(NTST,4)
      IF (NZ2 .GT. NR) NZ2=NR
      N=0
      IF (ENL) THEN
         WRITE(IOUT,9909) NAME
         WRITE(IOUT,9906)
      END IF
      DO 1850 J=1,NZ1
      M=0
      DO 1805 I=1,3
 1805 CEL(I)=STORE(J,I)
      DO 1840 K=J,NZ2
      IF (K .NE. J) GO TO 1808
      CEL(1)=STORE(J,2)
      CEL(2)=STORE(J,1)
 1808 DO 1810 I=1,3
 1810 CEL(I+3)=STORE(K,I)
      CALL REAR
      IF (CEL(4).LT. 0.1) GO TO 1840
      N=N+1
      N4=4*N
      L=10*J+K
      DO 1820 I=1,6
 1820 ROSTER(N4,I)=CEL(I)
      ROSTER(N4,8)=L
      ROSTER(N4,9)=0.5*(STORE(J,9)+STORE(K,9))
      IF (ENL) WRITE(IOUT,9907) J,K,(CEL(I),I=1,3),CEL(5),CEL(6),L,
     * TWORAD*ROSTER(N4,9)
C  CARE MUST BE TAKEN THAT THERE IS NO OVERFLOW IN *ROSTER*
C  ROSTER CAN CONTAIN 4*36+3 POSSIBLE LATTICES (150 IS MAXIMUM)
      IF (N .EQ. 36) THEN
         WRITE(IOUT,9925) N,J,K
         GO TO 1860
      END IF
      DO 1830 I=1,3
      M=M+1
 1830 CEL(I)=STORE(J,I)
      IF (M .GT. 4) GO TO 1840
      IF (K .EQ. J) GO TO 1808
 1840 CONTINUE
 1850 CONTINUE
      IF (N .GE. 6) GO TO 1860
      IF (NZ1 .EQ. NR) GO TO 1860
      NZ1=2*NZ1
      NZ2=2*NZ2
      GO TO 800
 1860 LINCO=4*N
      CALL TIMER(4)
      RETURN
 9901 FORMAT(32H0THE SEARCH FOR ZONES COMMENCES    )
 9902 FORMAT(1H0 , 70(1H*)  /
     2 11H *     ZONE,I3,8H INDEXES,I3,15H LINES FROM THE,I3,
     3 28H USED FOR ZONEFINDING      * /
     4 52H *     ZONE-FINDING IS RESTARTED WITH OTHER LINES.  ,
     5 18X,1H* / 1H ,70(1H*)  ///)
 9903 FORMAT(1H ,I3,3F8.1,F14.1 )
 9904 FORMAT(1H ,I3, 3F8.1, I4)
 9905 FORMAT(35H0 NR     A       B     FMAAS  HITS            )
 9906 FORMAT(1H0,
     *60H POSSIBLE COMBINATIONS OF ZONES (ON WHICH TO BASE A SEARCH  ,
     *15H FOR LATTICES)  /
     *62H COMBINATION A       B       C       D       E       F   NEWNR,
     * '  ZEROSHIFT' )
 9907 FORMAT(1H ,2I3,3F8.1,8H     XXX,2F8.1,I6, F8.4)
 9908 FORMAT(18H0THIS ZONE INDEXES ,I3,15H LINES FROM THE  ,I3,
     * 22H USED FOR ZONE-FINDING    )
 9909 FORMAT(1H1,20X,A80/1H ,60(2H--) )
 9910 FORMAT('0ZONES AFTER REFINEMENT ON TWOTHETA, ONLY THE',
     1  ' ZEROSHIFT IS USED' //
     2  ' NEWNR    A       B     FMAAS       QUALITY   OLDNR CENTER ',
     3  ' NOBS  NCALC  ZEROSHIFT' / )
 9911 FORMAT(1H , I4, 3F8.1,2X,F14.1, 4F6.0, F10.4)
 9912 FORMAT( ///' THE ZEROSHIFTS ARE NOT YET REALLY USED IN THE',
     * ' PROGRAM.'/ ' IF YOU SEE A CONVINCING ZERO SHIFT, YOU COULD',
     2 ' ENTER THE ZEROSHIFT (WITH THE OPPOSITE SIGN) ' /
     3 ' IN COL. 1-10 OF THE SECOND PARAMETER CARD, AND RERUN THE ' ,
     4 ' PROBLEM'  )
 9915 FORMAT('0UPPER BOUNDARIES FOR THE REGIONS OF THE PROBABILITIES',
     * ' GIVEN BELOW' / (1H ,10F12.2)  )
 9916 FORMAT(51H0PROBABILITIES OF FINDING A CALCULATED LINE IN THE ,
     2 38H PARTS OF THE Q-RANGE AS SHOWN  ABOVE   / (1H ,10E12.3) )
 9917 FORMAT(50H0TEST OUTPUT, MAINLY FROM SUBROUTINE  ** EVALU8 **    )
 9920 FORMAT(/42H SEARCH FOR ZONES TERMINATED - STORAGE FOR,I4,14H ZONES
     1 MAXIMUM/ 70H0TO SEARCH FURTHER COMBINATIONS YOU WILL HAVE TO SUBM
     2IT A SEPARATE RUN/60H WITH THE EXTRA LINE PAIRS SUPPLIED USING THE
     3 LINCO FACILITY)
 9922 FORMAT(///1H ,63(1H*)/,
     1 ' **  NO REALLY SATISFACTORY LATTICE HAS BEEN FOUND',
     2 '           ***'/  ' **  PROBLEM IS RERUN WITH A DIFFERENT',
     3 ' SORTING OF THE ZONES  ***'/ 1H ,63(1H*) )
 9925 FORMAT(1H0,78(1H*)/' MAXIMUM CAPACITY OF ROSTER IS REACHED'/
     1 ' NUMBER OF COMBINATIONS IS ',I3,
     2 '   THE LAST COMBINATION WAS  ',I2,'-',I2 / 1H0,78(1H*) )
 9930 FORMAT(' ZONE ',I2,5X,8F12.1, F8.4)
 9981 FORMAT(1H ,I3,3F8.1,F12.0,4F5.0,F8.3)
 9989 FORMAT(1H0,A70// 35(2H--) /
     1       ' ZONES AFTER EVALUATION AND REFINEMENT ON TWOTHETA'//
     2  ' NEWNR   A       B     FMAAS   QUALITY  OLDNR CNTR',
     3  ' NOBS NCALC ZERSHFT' / )
      END
